/[gentoo-x86]/eclass/vdr-plugin.eclass
Gentoo

Diff of /eclass/vdr-plugin.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.59 Revision 1.69
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/vdr-plugin.eclass,v 1.59 2008/04/23 13:56:20 zzam Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/vdr-plugin.eclass,v 1.69 2009/03/24 21:10:13 zzam Exp $
4# 4#
5# Author: 5# Author:
6# Matthias Schwarzott <zzam@gentoo.org> 6# Matthias Schwarzott <zzam@gentoo.org>
7# Joerg Bornkessel <hd_brummy@gentoo.org> 7# Joerg Bornkessel <hd_brummy@gentoo.org>
8 8
71 71
72# works in most cases 72# works in most cases
73S="${WORKDIR}/${VDRPLUGIN}-${PV}" 73S="${WORKDIR}/${VDRPLUGIN}-${PV}"
74 74
75# depend on headers for DVB-driver 75# depend on headers for DVB-driver
76DEPEND=">=media-tv/gentoo-vdr-scripts-0.3.8 76COMMON_DEPEND=">=media-tv/gentoo-vdr-scripts-0.4.2"
77 || ( >=media-tv/gentoo-vdr-scripts-0.4.2 >=media-tv/vdrplugin-rebuild-0.2 ) 77
78 >=app-admin/eselect-vdr-0.0.2 78DEPEND="${COMMON_DEPEND}
79 media-tv/linuxtv-dvb-headers" 79 media-tv/linuxtv-dvb-headers"
80RDEPEND="${COMMON_DEPEND}
81 >=app-admin/eselect-vdr-0.0.2"
80 82
83# this is a hack for ebuilds like vdr-xineliboutput that want to
84# conditionally install a vdr-plugin
85if [[ "${GENTOO_VDR_CONDITIONAL:-no}" = "yes" ]]; then
86 # make DEPEND conditional
87 IUSE="${IUSE} vdr"
88 DEPEND="vdr? ( ${DEPEND} )"
89 RDEPEND="vdr? ( ${RDEPEND} )"
90fi
81 91
82# New method of storing plugindb 92# New method of storing plugindb
83# Called from src_install 93# Called from src_install
84# file maintained by normal portage-methods 94# file maintained by normal portage-methods
85create_plugindb_file() { 95create_plugindb_file() {
97 { 107 {
98 echo "VDRPLUGIN_DB=1" 108 echo "VDRPLUGIN_DB=1"
99 echo "CREATOR=ECLASS" 109 echo "CREATOR=ECLASS"
100 echo "EBUILD=${CATEGORY}/${PN}" 110 echo "EBUILD=${CATEGORY}/${PN}"
101 echo "EBUILD_V=${PVR}" 111 echo "EBUILD_V=${PVR}"
112 echo "PLUGINS=\"$@\""
102 } > "${D}/${DB_FILE}" 113 } > "${D}/${DB_FILE}"
103} 114}
104 115
105# Delete files created outside of vdr-plugin.eclass 116# Delete files created outside of vdr-plugin.eclass
106# vdrplugin-rebuild.ebuild converted plugindb and files are 117# vdrplugin-rebuild.ebuild converted plugindb and files are
130create_header_checksum_file() 141create_header_checksum_file()
131{ 142{
132 # Danger: Not using $ROOT here, as compile will also not use it !!! 143 # Danger: Not using $ROOT here, as compile will also not use it !!!
133 # If vdr in $ROOT and / differ, plugins will not run anyway 144 # If vdr in $ROOT and / differ, plugins will not run anyway
134 145
146 local CHKSUM="header-md5-vdr"
147
148 if [[ -f ${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then
149 cp "${VDR_CHECKSUM_DIR}/header-md5-vdr" "${CHKSUM}"
150 elif type -p md5sum >/dev/null 2>&1; then
151 (
152 cd "${VDR_INCLUDE_DIR}"
153 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2
154 ) > "${CHKSUM}"
155 else
156 die "Could not create md5 checksum of headers"
157 fi
158
135 insinto "${VDR_CHECKSUM_DIR}" 159 insinto "${VDR_CHECKSUM_DIR}"
136 if [[ -f ${VDR_CHECKSUM_DIR}/header-md5-vdr ]]; then 160 local p_name
137 newins "${VDR_CHECKSUM_DIR}/header-md5-vdr header-md5-${PN}" 161 for p_name; do
138 else 162 newins "${CHKSUM}" "header-md5-${p_name}"
139 if type -p md5sum >/dev/null 2>&1; then 163 done
140 cd "${S}"
141 (
142 cd "${VDR_INCLUDE_DIR}"
143 md5sum *.h libsi/*.h|LC_ALL=C sort --key=2
144 ) > header-md5-${PN}
145 doins header-md5-${PN}
146 fi
147 fi
148} 164}
149 165
150fix_vdr_libsi_include() 166fix_vdr_libsi_include()
151{ 167{
152 einfo "Fixing include of libsi-headers" 168 einfo "Fixing include of libsi-headers"
161vdr_patchmakefile() { 177vdr_patchmakefile() {
162 einfo "Patching Makefile" 178 einfo "Patching Makefile"
163 [[ -e Makefile ]] || die "Makefile of plugin can not be found!" 179 [[ -e Makefile ]] || die "Makefile of plugin can not be found!"
164 cp Makefile "${WORKDIR}"/Makefile.before 180 cp Makefile "${WORKDIR}"/Makefile.before
165 181
182 # plugin makefiles use VDRDIR in strange ways
183 # assumptions:
184 # 1. $(VDRDIR) contains Make.config
185 # 2. $(VDRDIR) contains config.h
186 # 3. $(VDRDIR)/include/vdr contains the headers
187 # 4. $(VDRDIR) contains main vdr Makefile
188 # 5. $(VDRDIR)/locale exists
189 # 6. $(VDRDIR) allows to access vdr source files
190 #
191 # We only have one directory (for now /usr/include/vdr),
192 # that contains vdr-headers and Make.config.
193 # To satisfy 1-3 we do this:
194 # Set VDRDIR=/usr/include/vdr
195 # Set VDRINCDIR=/usr/include
196 # Change $(VDRDIR)/include to $(VDRINCDIR)
197
166 ebegin " Setting Pathes" 198 ebegin " Setting paths"
167 sed -i Makefile \ 199 sed -i Makefile \
168 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \ 200 -e "s:^VDRDIR.*$:VDRDIR = ${VDR_INCLUDE_DIR}:" \
169 -e "s:^LIBDIR.*$:LIBDIR = ${S}:" \ 201 -e "/^VDRDIR/a VDRINCDIR = ${VDR_INCLUDE_DIR%/vdr}" \
170 -e "s:^TMPDIR.*$:TMPDIR = ${T}:" \ 202 -e '/VDRINCDIR.*=/!s:$(VDRDIR)/include:$(VDRINCDIR):' \
171 -e 's:-I$(VDRDIR)/include:-I'"${VDR_INCLUDE_DIR%vdr}"':' \ 203 \
172 -e "/^DVBDIR/d" \
173 -e 's:-I$(DVBDIR)/include::' \ 204 -e 's:-I$(DVBDIR)/include::' \
174 -e 's:-I$(DVBDIR)::' 205 -e 's:-I$(DVBDIR)::'
175 eend $? 206 eend 0
176 207
177 # maybe needed for multiproto: 208 # maybe needed for multiproto:
178 #sed -i Makefile \ 209 #sed -i Makefile \
179 # -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \ 210 # -e "s:^DVBDIR.*$:DVBDIR = ${DVB_INCLUDE_DIR}:" \
180 # -e 's:-I$(VDRDIR)/include -I$(DVBDIR)/include:-I$(DVBDIR)/include -I$(VDRDIR)/include:' \
181 # -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):' 211 # -e 's:-I$(DVBDIR)/include:-I$(DVBDIR):'
182 212
183 if ! grep -q APIVERSION Makefile; then 213 if ! grep -q APIVERSION Makefile; then
184 ebegin " Converting to APIVERSION" 214 ebegin " Converting to APIVERSION"
185 sed -i Makefile \ 215 sed -i Makefile \
275vdr_i18n() { 305vdr_i18n() {
276 if vdr_has_gettext; then 306 if vdr_has_gettext; then
277 einfo "VDR has gettext support" 307 einfo "VDR has gettext support"
278 if plugin_has_gettext; then 308 if plugin_has_gettext; then
279 einfo "Plugin has gettext support, fine" 309 einfo "Plugin has gettext support, fine"
310 if [[ ${NO_GETTEXT_HACK} == "1" ]]; then
311 ewarn "Please remove left over NO_GETTEXT_HACK."
312 fi
280 else 313 else
281 vdr_i18n_convert_to_gettext 314 vdr_i18n_convert_to_gettext
282 if [[ $? != 0 ]]; then 315 if [[ $? != 0 ]]; then
283 eerror "" 316 eerror ""
284 eerror "Plugin will have only english OSD texts" 317 eerror "Plugin will have only english OSD texts"
315 348
316 dosym "${VDRPLUGIN}-${PV}" "${destdir}" 349 dosym "${VDRPLUGIN}-${PV}" "${destdir}"
317} 350}
318 351
319vdr-plugin_print_enable_command() { 352vdr-plugin_print_enable_command() {
353 local p_name c=0 l=""
354 for p_name in ${vdr_plugin_list}; do
355 c=$(( c+1 ))
356 l="$l ${p_name#vdr-}"
357 done
358
320 elog 359 elog
360 case $c in
361 1) elog "Installed plugin${l}" ;;
362 *) elog "Installed $c plugins:${l}" ;;
363 esac
321 elog "To activate this vdr-plugin execute the following command:" 364 elog "To activate a plugin execute this command:"
322 elog "\teselect vdr-plugin enable ${PN#vdr-}" 365 elog "\teselect vdr-plugin enable <plugin_name> ..."
323 elog 366 elog
324} 367}
325 368
369has_vdr() {
370 [[ -f "${VDR_INCLUDE_DIR}"/config.h ]]
371}
326 372
327## exported functions 373## exported functions
328 374
329vdr-plugin_pkg_setup() { 375vdr-plugin_pkg_setup() {
330 # -fPIC is needed for shared objects on some platforms (amd64 and others) 376 # -fPIC is needed for shared objects on some platforms (amd64 and others)
340 386
341 # Pathes to includes 387 # Pathes to includes
342 VDR_INCLUDE_DIR="/usr/include/vdr" 388 VDR_INCLUDE_DIR="/usr/include/vdr"
343 DVB_INCLUDE_DIR="/usr/include" 389 DVB_INCLUDE_DIR="/usr/include"
344 390
345
346 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale" 391 TMP_LOCALE_DIR="${WORKDIR}/tmp-locale"
347 LOCDIR="/usr/share/vdr/locale" 392 LOCDIR="/usr/share/vdr/locale"
348 393
394 if ! has_vdr; then
395 # set to invalid values to detect abuses
396 VDRVERSION="eclass_no_vdr_installed"
397 APIVERSION="eclass_no_vdr_installed"
398
399 if [[ "${GENTOO_VDR_CONDITIONAL:-no}" = "yes" ]] && ! use vdr; then
400 einfo "VDR not found!"
401 else
402 # if vdr is required
403 die "VDR not found!"
404 fi
405 return
406 fi
407
349 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h) 408 VDRVERSION=$(awk -F'"' '/define VDRVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
350 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h) 409 APIVERSION=$(awk -F'"' '/define APIVERSION/ {print $2}' "${VDR_INCLUDE_DIR}"/config.h)
351 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}" 410 [[ -z ${APIVERSION} ]] && APIVERSION="${VDRVERSION}"
352 411
353 einfo "Compiling against" 412 einfo "Compiling against"
354 einfo "\tvdr-${VDRVERSION} [API version ${APIVERSION}]" 413 einfo "\tvdr-${VDRVERSION} [API version ${APIVERSION}]"
414}
415
416vdr-plugin_src_util() {
417
418 while [ "$1" ]; do
419
420 case "$1" in
421 all)
422 vdr-plugin_src_util unpack add_local_patch patchmakefile i18n
423 ;;
424 prepare|all_but_unpack)
425 vdr-plugin_src_util add_local_patch patchmakefile i18n
426 ;;
427 unpack)
428 base_src_unpack
429 ;;
430 add_local_patch)
431 cd "${S}" || die "Could not change to plugin-source-directory!"
432 vdr_add_local_patch
433 ;;
434 patchmakefile)
435 cd "${S}" || die "Could not change to plugin-source-directory!"
436 vdr_patchmakefile
437 ;;
438 i18n)
439 cd "${S}" || die "Could not change to plugin-source-directory!"
440 vdr_i18n
441 ;;
442 esac
443
444 shift
445 done
355} 446}
356 447
357vdr-plugin_src_unpack() { 448vdr-plugin_src_unpack() {
358 if [[ -z ${VDR_INCLUDE_DIR} ]]; then 449 if [[ -z ${VDR_INCLUDE_DIR} ]]; then
359 eerror "Wrong use of vdr-plugin.eclass." 450 eerror "Wrong use of vdr-plugin.eclass."
360 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup." 451 eerror "An ebuild for a vdr-plugin will not work without calling vdr-plugin_pkg_setup."
361 echo 452 echo
362 eerror "Please report this at bugs.gentoo.org." 453 eerror "Please report this at bugs.gentoo.org."
363 die "vdr-plugin_pkg_setup not called!" 454 die "vdr-plugin_pkg_setup not called!"
364 fi 455 fi
365 [ -z "$1" ] && vdr-plugin_src_unpack unpack add_local_patch patchmakefile i18n 456 if [ -z "$1" ]; then
457 case "${EAPI:-0}" in
458 2)
459 vdr-plugin_src_util unpack
460 ;;
461 *)
462 vdr-plugin_src_util all
463 ;;
464 esac
465
466 else
467 vdr-plugin_src_util $@
468 fi
469}
470
471vdr-plugin_src_prepare() {
472 base_src_prepare
473 vdr-plugin_src_util prepare
474}
475
476vdr-plugin_src_compile() {
477 [ -z "$1" ] && vdr-plugin_src_compile copy_source compile
366 478
367 while [ "$1" ]; do 479 while [ "$1" ]; do
368 480
369 case "$1" in 481 case "$1" in
370 all_but_unpack) 482 copy_source)
371 vdr-plugin_src_unpack add_local_patch patchmakefile i18n
372 ;;
373 unpack)
374 base_src_unpack
375 ;;
376 add_local_patch)
377 cd "${S}" || die "Could not change to plugin-source-directory!"
378 vdr_add_local_patch
379 ;;
380 patchmakefile)
381 cd "${S}" || die "Could not change to plugin-source-directory!"
382 vdr_patchmakefile
383 ;;
384 i18n)
385 cd "${S}" || die "Could not change to plugin-source-directory!"
386 vdr_i18n
387 ;;
388 esac
389
390 shift
391 done
392}
393
394vdr-plugin_src_compile() {
395 [ -z "$1" ] && vdr-plugin_src_compile prepare compile
396
397 while [ "$1" ]; do
398
399 case "$1" in
400 prepare)
401 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree 483 [[ -n "${VDRSOURCE_DIR}" ]] && vdr-plugin_copy_source_tree
402 ;; 484 ;;
403 compile) 485 compile)
404 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then 486 if [[ ! -f ${WORKDIR}/.vdr-plugin_makefile_patched ]]; then
405 eerror "Wrong use of vdr-plugin.eclass." 487 eerror "Wrong use of vdr-plugin.eclass."
409 eerror "Please report this at bugs.gentoo.org." 491 eerror "Please report this at bugs.gentoo.org."
410 die "vdr-plugin_src_unpack not called!" 492 die "vdr-plugin_src_unpack not called!"
411 fi 493 fi
412 cd "${S}" 494 cd "${S}"
413 495
496 BUILD_TARGETS=${BUILD_TARGETS:-${VDRPLUGIN_MAKE_TARGET:-all}}
497
414 emake ${BUILD_PARAMS} \ 498 emake ${BUILD_PARAMS} \
415 ${VDRPLUGIN_MAKE_TARGET:-all} \ 499 ${BUILD_TARGETS} \
416 LOCALEDIR="${TMP_LOCALE_DIR}" \ 500 LOCALEDIR="${TMP_LOCALE_DIR}" \
501 LIBDIR="${S}" \
502 TMPDIR="${T}" \
417 || die "emake failed" 503 || die "emake failed"
418 ;; 504 ;;
419 esac 505 esac
420 506
421 shift 507 shift
442 insinto "/usr/share/vdr/maintainer-data/makefile-patched" 528 insinto "/usr/share/vdr/maintainer-data/makefile-patched"
443 doins "${mname}.patched" 529 doins "${mname}.patched"
444 530
445 fi 531 fi
446 532
533
534
447 cd "${S}" 535 cd "${S}"
448 insinto "${VDR_PLUGIN_DIR}" 536 insinto "${VDR_PLUGIN_DIR}"
449 doins libvdr-*.so.* 537 doins libvdr-*.so.*
538
539 # create list of all created plugin libs
540 vdr_plugin_list=""
541 local p_name
542 for p in libvdr-*.so.*; do
543 p_name="${p%.so*}"
544 p_name="${p_name#lib}"
545 vdr_plugin_list="${vdr_plugin_list} ${p_name}"
546 done
547
548 create_header_checksum_file ${vdr_plugin_list}
549 create_plugindb_file ${vdr_plugin_list}
450 550
451 if vdr_has_gettext && [[ -d ${TMP_LOCALE_DIR} ]]; then 551 if vdr_has_gettext && [[ -d ${TMP_LOCALE_DIR} ]]; then
452 einfo "Installing locales" 552 einfo "Installing locales"
453 cd "${TMP_LOCALE_DIR}" 553 cd "${TMP_LOCALE_DIR}"
454 insinto "${LOCDIR}" 554 insinto "${LOCDIR}"
474 574
475 if [[ -n ${VDR_RCADDON_FILE} ]]; then 575 if [[ -n ${VDR_RCADDON_FILE} ]]; then
476 insinto "${VDR_RC_DIR}" 576 insinto "${VDR_RC_DIR}"
477 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh 577 newins "${VDR_RCADDON_FILE}" plugin-${VDRPLUGIN}.sh
478 fi 578 fi
479
480 create_header_checksum_file
481 create_plugindb_file
482} 579}
483 580
484vdr-plugin_pkg_postinst() { 581vdr-plugin_pkg_postinst() {
485 vdr-plugin_print_enable_command 582 vdr-plugin_print_enable_command
486 583
498vdr-plugin_pkg_config() { 595vdr-plugin_pkg_config() {
499 ewarn "emerge --config ${PN} is no longer supported" 596 ewarn "emerge --config ${PN} is no longer supported"
500 vdr-plugin_print_enable_command 597 vdr-plugin_print_enable_command
501} 598}
502 599
600case "${EAPI:-0}" in
601 2)
602 EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_compile src_install pkg_postinst pkg_postrm pkg_config
603 ;;
604 *)
503EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config 605 EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_install pkg_postinst pkg_postrm pkg_config
606 ;;
607esac

Legend:
Removed from v.1.59  
changed lines
  Added in v.1.69

  ViewVC Help
Powered by ViewVC 1.1.20